diff --git a/src/third_party/wiredtiger/dist/api_data.py b/src/third_party/wiredtiger/dist/api_data.py
index 5eb48bcda5..5f049674fc 100644
--- a/src/third_party/wiredtiger/dist/api_data.py
+++ b/src/third_party/wiredtiger/dist/api_data.py
@@ -555,13 +555,13 @@ connection_runtime_config = [
         greater than 100. The value is not allowed to exceed the \c cache_size.
         Ignored if set to zero or \c in_memory is \c true''',
         min=0, max='10TB'),
-    Config('eviction_dirty_target', '5', r'''
+    Config('eviction_dirty_target', '2.5', r'''
         perform eviction in worker threads when the cache contains at least
         this much dirty content. It is a percentage of the cache size if the
         value is within the range of 1 to 100 or an absolute size when greater
         than 100. The value is not allowed to exceed the \c cache_size.''',
         min=1, max='10TB'),
-    Config('eviction_dirty_trigger', '20', r'''
+    Config('eviction_dirty_trigger', '10', r'''
         trigger application threads to perform eviction when the cache contains
         at least this much dirty content. It is a percentage of the cache size
         if the value is within the range of 1 to 100 or an absolute size when
diff --git a/src/third_party/wiredtiger/src/config/config_def.c b/src/third_party/wiredtiger/src/config/config_def.c
index 531af81ae0..61ee8c8e2e 100644
--- a/src/third_party/wiredtiger/src/config/config_def.c
+++ b/src/third_party/wiredtiger/src/config/config_def.c
@@ -821,8 +821,8 @@ static const WT_CONFIG_ENTRY config_entries[] = {{"WT_CONNECTION.add_collator",
     "eviction=false,realloc_exact=false,rollback_error=0,"
     "slow_checkpoint=false,table_logging=false),error_prefix=,"
     "eviction=(threads_max=8,threads_min=1),"
-    "eviction_checkpoint_target=1,eviction_dirty_target=5,"
-    "eviction_dirty_trigger=20,eviction_target=80,eviction_trigger=95"
+    "eviction_checkpoint_target=1,eviction_dirty_target=2.5,"
+    "eviction_dirty_trigger=10,eviction_target=80,eviction_trigger=95"
     ",file_manager=(close_handle_minimum=250,close_idle_time=30,"
     "close_scan_interval=10),io_capacity=(total=0),log=(archive=true,"
     "os_cache_dirty_pct=0,prealloc=true,zero_fill=false),"
@@ -996,8 +996,8 @@ static const WT_CONFIG_ENTRY config_entries[] = {{"WT_CONNECTION.add_collator",
     "slow_checkpoint=false,table_logging=false),direct_io=,"
     "encryption=(keyid=,name=,secretkey=),error_prefix=,"
     "eviction=(threads_max=8,threads_min=1),"
-    "eviction_checkpoint_target=1,eviction_dirty_target=5,"
-    "eviction_dirty_trigger=20,eviction_target=80,eviction_trigger=95"
+    "eviction_checkpoint_target=1,eviction_dirty_target=2.5,"
+    "eviction_dirty_trigger=10,eviction_target=80,eviction_trigger=95"
     ",exclusive=false,extensions=,file_extend=,"
     "file_manager=(close_handle_minimum=250,close_idle_time=30,"
     "close_scan_interval=10),hazard_max=1000,in_memory=false,"
@@ -1027,8 +1027,8 @@ static const WT_CONFIG_ENTRY config_entries[] = {{"WT_CONNECTION.add_collator",
     "slow_checkpoint=false,table_logging=false),direct_io=,"
     "encryption=(keyid=,name=,secretkey=),error_prefix=,"
     "eviction=(threads_max=8,threads_min=1),"
-    "eviction_checkpoint_target=1,eviction_dirty_target=5,"
-    "eviction_dirty_trigger=20,eviction_target=80,eviction_trigger=95"
+    "eviction_checkpoint_target=1,eviction_dirty_target=2.5,"
+    "eviction_dirty_trigger=10,eviction_target=80,eviction_trigger=95"
     ",exclusive=false,extensions=,file_extend=,"
     "file_manager=(close_handle_minimum=250,close_idle_time=30,"
     "close_scan_interval=10),hazard_max=1000,in_memory=false,"
@@ -1057,8 +1057,8 @@ static const WT_CONFIG_ENTRY config_entries[] = {{"WT_CONNECTION.add_collator",
     "rollback_error=0,slow_checkpoint=false,table_logging=false),"
     "direct_io=,encryption=(keyid=,name=,secretkey=),error_prefix=,"
     "eviction=(threads_max=8,threads_min=1),"
-    "eviction_checkpoint_target=1,eviction_dirty_target=5,"
-    "eviction_dirty_trigger=20,eviction_target=80,eviction_trigger=95"
+    "eviction_checkpoint_target=1,eviction_dirty_target=2.5,"
+    "eviction_dirty_trigger=10,eviction_target=80,eviction_trigger=95"
     ",extensions=,file_extend=,file_manager=(close_handle_minimum=250"
     ",close_idle_time=30,close_scan_interval=10),hazard_max=1000,"
     "io_capacity=(total=0),log=(archive=true,compressor=,"
@@ -1085,8 +1085,8 @@ static const WT_CONFIG_ENTRY config_entries[] = {{"WT_CONNECTION.add_collator",
     "rollback_error=0,slow_checkpoint=false,table_logging=false),"
     "direct_io=,encryption=(keyid=,name=,secretkey=),error_prefix=,"
     "eviction=(threads_max=8,threads_min=1),"
-    "eviction_checkpoint_target=1,eviction_dirty_target=5,"
-    "eviction_dirty_trigger=20,eviction_target=80,eviction_trigger=95"
+    "eviction_checkpoint_target=1,eviction_dirty_target=2.5,"
+    "eviction_dirty_trigger=10,eviction_target=80,eviction_trigger=95"
     ",extensions=,file_extend=,file_manager=(close_handle_minimum=250"
     ",close_idle_time=30,close_scan_interval=10),hazard_max=1000,"
     "io_capacity=(total=0),log=(archive=true,compressor=,"