diff --git a/src/meta/meta_ckpt.c b/src/meta/meta_ckpt.c
index 3c041932d..988a8404e 100644
--- a/src/meta/meta_ckpt.c
+++ b/src/meta/meta_ckpt.c
@@ -208,6 +208,8 @@ __ckpt_set(WT_SESSION_IMPL *session, const char *fname, const char *v, bool use_
      */
     config = newcfg = NULL;
     dhandle = session->dhandle;
+    if (v != NULL && strcmp(fname, WT_METAFILE_URI) != 0)
+        __wt_verbose(session, WT_VERB_TEMPORARY, "CKPT_SET: file %s v %s", fname, v);
     str = v == NULL ? "checkpoint=(),checkpoint_backup_info=(),checkpoint_lsn=" : v;
     if (use_base && dhandle != NULL) {
         WT_ERR(__wt_scr_alloc(session, 0, &tmp));
@@ -1338,6 +1340,16 @@ __wt_meta_sysinfo_set(WT_SESSION_IMPL *session)
         WT_ERR(__wt_buf_catfmt(session, buf, "%" PRIu64 "%s", txn->snapshot[snap_count], "]"));
     }
     WT_ERR(__wt_metadata_update(session, WT_SYSTEM_CKPT_SNAPSHOT_URI, buf->data));
+    __wt_verbose(session, WT_VERB_TEMPORARY,
+      "saving checkpoint snapshot min: %" PRIu64 ", snapshot max: %" PRIu64
+      " snapshot count: %" PRIu32
+      ", oldest timestamp: %s , meta checkpoint timestamp: %s"
+      " base write gen: %" PRIu64
+      " BUF: %s",
+      txn->snap_min, txn->snap_max, txn->snapshot_count,
+      __wt_timestamp_to_string(txn_global->oldest_timestamp, ts_string[0]),
+      __wt_timestamp_to_string(txn_global->meta_ckpt_timestamp, ts_string[1]),
+      S2C(session)->base_write_gen, buf->data);
 
     __wt_verbose(session, WT_VERB_CHECKPOINT_PROGRESS,
       "saving checkpoint snapshot min: %" PRIu64 ", snapshot max: %" PRIu64
diff --git a/src/session/session_api.c b/src/session/session_api.c
index 55d1619c1..db1829579 100644
--- a/src/session/session_api.c
+++ b/src/session/session_api.c
@@ -743,13 +743,24 @@ __session_alter(WT_SESSION *wt_session, const char *uri, const char *config)
      * the command after performing a system wide checkpoint. Only retry once to avoid potentially
      * waiting forever.
      */
+#if 0
     ret = __session_alter_internal(session, uri, config);
+#else
+    ret = EBUSY;
+#endif
     if (ret == EBUSY) {
+	__wt_verbose(session, WT_VERB_TEMPORARY, "ALTER: EBUSY CHECKPOINT uri %s", uri);
         WT_RET(__session_blocking_checkpoint(session));
+	__wt_verbose(session, WT_VERB_TEMPORARY, "ALTER: EBUSY DONE uri %s", uri);
         WT_STAT_CONN_INCR(session, session_table_alter_trigger_checkpoint);
+#if 0
         ret = __session_alter_internal(session, uri, config);
+#else
+	ret = EBUSY;
+#endif
     }
 
+    __wt_verbose(session, WT_VERB_TEMPORARY, "ALTER: ret %d uri %s", ret, uri);
     return (ret);
 }
 
diff --git a/src/txn/txn_ckpt.c b/src/txn/txn_ckpt.c
index 3981a0902..6709c3ad1 100644
--- a/src/txn/txn_ckpt.c
+++ b/src/txn/txn_ckpt.c
@@ -2104,10 +2104,18 @@ __wt_checkpoint_close(WT_SESSION_IMPL *session, bool final)
      * is a stable timestamp set or the connection is configured to disallow such operation.
      * Flushing trees can lead to files that are inconsistent on disk after a crash.
      */
+    if (!metadata && !bulk)
+        __wt_verbose(session, WT_VERB_TEMPORARY,
+          "CKPT_CLOSE: modified %d immed_durable %d FILE_CLOSE %d", btree->modified,
+          __wt_btree_immediately_durable(session), F_ISSET(S2C(session), WT_CONN_FILE_CLOSE_SYNC));
     if (btree->modified && !bulk && !__wt_btree_immediately_durable(session) &&
       (S2C(session)->txn_global.has_stable_timestamp ||
-        (!F_ISSET(S2C(session), WT_CONN_FILE_CLOSE_SYNC) && !metadata)))
+        (!F_ISSET(S2C(session), WT_CONN_FILE_CLOSE_SYNC) && !metadata))) {
+        __wt_verbose(session, WT_VERB_TEMPORARY, "%s", "CKPT_CLOSE: return EBUSY");
         return (__wt_set_return(session, EBUSY));
+    }
+    if (!metadata && !bulk)
+        __wt_verbose(session, WT_VERB_TEMPORARY, "%s", "CKPT_CLOSE: PROCEED");
 
     /*
      * Make sure there isn't a potential race between backup copying the metadata and a checkpoint
diff --git a/test/format/alter.c b/test/format/alter.c
index 7fab67e4f..acf4996b9 100644
--- a/test/format/alter.c
+++ b/test/format/alter.c
@@ -40,7 +40,7 @@ alter(void *arg)
     WT_CONNECTION *conn;
     WT_DECL_RET;
     WT_SESSION *session;
-    u_int period;
+    u_int counter, period;
     char buf[32];
     bool access_value;
 
@@ -57,6 +57,7 @@ alter(void *arg)
     /* Open a session */
     memset(&sap, 0, sizeof(sap));
     wiredtiger_open_session(conn, &sap, NULL, &session);
+    counter = 0;
 
     while (!g.workers_finished) {
         period = mmrand(NULL, 1, 10);
@@ -67,14 +68,18 @@ alter(void *arg)
 
         /* Alter can return EBUSY if concurrent with other operations. */
         table = table_select(NULL);
+	trace_msg(session, "Alter #%u URI %s start %s", ++counter, table->uri, buf);
+
         while ((ret = session->alter(session, table->uri, buf)) != 0 && ret != EBUSY)
             testutil_die(ret, "session.alter");
+	trace_msg(session, "Alter #%u URI %s stop", counter, table->uri);
         while (period > 0 && !g.workers_finished) {
             --period;
             __wt_sleep(1, 0);
         }
     }
 
+    trace_msg(session, "Alter #%u CLOSE", counter);
     wiredtiger_close_session(session);
     return (WT_THREAD_RET_VALUE);
 }